{{- if .Values.sendTransactionsWorker.enabled }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "tezos-api-gateway.fullname" . }}-send-transactions-worker
  namespace: {{ .Release.Namespace }}
  labels:
    {{- include "tezos-api-gateway.labels" . | nindent 4 }}
    app.kubernetes.io/component: send-transactions-worker
  annotations:
    reloader.stakater.com/auto: "true"
spec:
  {{- if not .Values.sendTransactionsWorker.autoscaling.enabled }}
  replicas: {{ .Values.sendTransactionsWorker.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "tezos-api-gateway.selectorLabels" . | nindent 6 }}
      app.kubernetes.io/component: send-transactions-worker
  template:
    metadata:
      {{- with .Values.sendTransactionsWorker.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "tezos-api-gateway.selectorLabels" . | nindent 8 }}
        app.kubernetes.io/component: send-transactions-worker
        {{ .Release.Name }}-{{ .Values.db.nameOverride }}-client: "true"
        {{ .Release.Name }}-{{ .Values.rabbitmq.nameOverride }}-client: "true"
        {{ .Release.Name }}-{{ .Values.vault.nameOverride }}-client: "true"
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "tezos-api-gateway.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.sendTransactionsWorker.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.sendTransactionsWorker.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          command: ["node", "build/src/processes/workers/send-transactions/index.js"]
          env:
            - name: DB_USERNAME
              value: {{ .Values.db.postgresqlUsername | quote }}
            - name: DB_NAME
              value: {{ .Values.db.postgresqlDatabase | quote }}
            - name: DB_PWD
              valueFrom:
                secretKeyRef:
                  name: "{{ .Release.Name }}-{{ .Values.db.nameOverride }}"
                  key: postgresql-password
            - name: DB_HOST
              value: "{{ .Release.Name }}-{{ .Values.db.nameOverride }}"
            - name: AMQP_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: "{{ .Release.Name }}-{{ .Values.rabbitmq.nameOverride }}"
                  key: rabbitmq-password
            - name: AMQP_URL
              value: "amqp://user:$(AMQP_PASSWORD)@{{ .Release.Name }}-{{ .Values.rabbitmq.nameOverride }}"
            - name: VAULT_URL
              value: "http://{{ .Release.Name }}-{{ .Values.vault.nameOverride }}:{{ .Values.vault.service.port }}/v1/"
            - name: VAULT_TOKEN
              valueFrom:
                secretKeyRef:
                  name: {{ include "tezos-api-gateway.vault.fullname" . }}-root-token
                  key: root-token
            {{- range $key, $value := .Values.extraEnvVars }}
            - name: {{ $key }}
              value: {{ $value | quote }}
            {{- end }}
          ports:
            - name: prometheus
              containerPort: 9466
              protocol: TCP
          livenessProbe:
            exec:
              command: ['pidof', 'node']
          readinessProbe:
            exec:
              command: ['pidof', 'node']
          resources:
            {{- toYaml .Values.sendTransactionsWorker.resources | nindent 12 }}
      {{- with .Values.sendTransactionsWorker.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.sendTransactionsWorker.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.sendTransactionsWorker.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
{{- end }}
